// import QtQuick 1.0 // to target S60 5th Edition or Maemo 5
import QtQuick 1.1
import com.nokia.meego 1.0

Page {
	property variant stockQuoteDetails
	tools: ToolBarLayout {
		visible: true
		ToolIcon {
			iconId: "toolbar-back"
			anchors.left: (parent === undefined) ? undefined : parent.left
			onClicked: pageStack.pop();
		}
	}
	Rectangle {
		id: header
		anchors.top: parent.top
		anchors.left: parent.left		
		width: parent.width
		height: parent.height/10
		color: "#027dca"
		Text {
			id: companyHeader
			anchors.left: parent.left
			anchors.leftMargin: 6
			anchors.verticalCenter: parent.verticalCenter
			font.pointSize: 25
			color: "white"
			text: qsTr(parent.parent.stockQuoteDetails['Symbol'])
		}
	}
	Rectangle {
		id: companyStocksQuoteDetails
		anchors.top: header.bottom
		anchors.left: parent.left
		anchors.bottom: parent.bottom
		width: parent.width
		Text {
			id: companyName
			anchors.top: parent.top
			horizontalAlignment: Text.AlignHCenter
			width: parent.width
			height: lineCount * 40
			font.pointSize: 20
			font.bold: true
			wrapMode: Text.WrapAtWordBoundaryOrAnywhere
            text: stockQuoteDetails['Name']
		}
		Text {
			id: stockPriceChange
			anchors.top: companyName.bottom
			horizontalAlignment: Text.AlignHCenter
			width: parent.width
			height: 50
			font.pointSize: 30
			font.bold: true
			wrapMode: Text.WrapAnywhere
			text: stockQuoteDetails['P.Close'] + " <font color=\""+stockQuoteDetails['changeEffect']+"\">"+stockQuoteDetails['Change']+" ("+stockQuoteDetails['Change (%)']+"%)"+"</font>"
		}
		Column {
			anchors.top: stockPriceChange.bottom
			anchors.bottom: parent.bottom
			anchors.left: parent.left
			width: parent.width
			Rectangle {
				width: parent.width
				height: 40
				Text {
					anchors.left: parent.left
					anchors.verticalCenter: parent.verticalCenter
					text: "High: " + stockQuoteDetails['High']
					font.pointSize: 15
				}
				Text {
					anchors.right: parent.right
					anchors.verticalCenter: parent.verticalCenter
					text: "Low: " + stockQuoteDetails['Low']
					font.pointSize: 15
				}
			}
			Rectangle {
				width: parent.width
				height: 40
				Text {
					anchors.left: parent.left
					anchors.verticalCenter: parent.verticalCenter
					text: "Ask: " + stockQuoteDetails['Ask']
					font.pointSize: 15
				}
				Text {
					anchors.right: parent.right
					anchors.verticalCenter: parent.verticalCenter
					text: "Ask Vol.: " + stockQuoteDetails['Ask Vol.']
					font.pointSize: 15
				}
			}
			Rectangle {
				width: parent.width
				height: 40
				Text {
					anchors.left: parent.left
					anchors.verticalCenter: parent.verticalCenter
					text: "Bid: " + stockQuoteDetails['Bid']
					font.pointSize: 15
				}
				Text {
					anchors.right: parent.right
					anchors.verticalCenter: parent.verticalCenter
					text: "Bid Vol.: " + stockQuoteDetails['Bid Vol']
					font.pointSize: 15
				}
			}
			Rectangle {
				width: parent.width
				height: 40
				Text {
					anchors.left: parent.left
					anchors.verticalCenter: parent.verticalCenter
					text: "Trades: " + stockQuoteDetails['Trades']
					font.pointSize: 15
				}
				Text {
					anchors.right: parent.right
					anchors.verticalCenter: parent.verticalCenter
					text: "Volume: " + stockQuoteDetails['Volume']
					font.pointSize: 15
				}
			}
		}

	}
}
