WorkerScript.onMessage = function(msg) {
				 var dataStatus = 0;
				 var tableHeader = "";
				 var tableHeaderCells = [];
				 var tableBody = "";
				 var tableBodyCells = {};
				 var errorMessage = {};
				 try {
					 var request = new XMLHttpRequest();

				 } catch (e) {
					 console.log("unable to create XMLHTTPRequest object.");
					 return;
				 }
				 if (msg.action == "updateStockQuotesList") {
					 request.onreadystatechange = function(dataStatus) {
								 if (request.readyState == 3) {
									 console.log("request status : ",request.status);
								 }
								 if (request.readyState == 4) {
									 if (request.status != 200) {
										 errorMessage["error"] = "Internet Connection error or Data source is down.";
										 WorkerScript.sendMessage({'reply': errorMessage});
										 return;
									 }
									 var listEmpty = false;
									 if (msg.model.count == 0) {
										 listEmpty = true;
									 } else {
										 listEmpty = false;
									 }
									 var webpage = request.responseText;
									 if (webpage.match(/<div\s*class\s*=\s*"market-watch-table"\s*>\s*<h3[\s\S]*<\/h3>\s*<table[^<>]*>\s*<tr>(.*)<\/tr>\s*<\/table>[\s\S]*<tbody>([\s\S]*)<\/tbody>/)) {
										 tableHeader = RegExp.$1;
										 tableBody = RegExp.$2;
									 } else {
										 //error no data found
										 console.log("No Data found.");
										 errorMessage["error"] = "Data source is incorrect.";
										 WorkerScript.sendMessage({'reply': errorMessage});
										 return;
									 }
									 webpage.match(/<span.*id\s*=\s*"ctl00_ms_spanStatus".*>(.*)<\/span>/);
									 var marketStatus = RegExp.$1;
									 while((tableHeader.match(/^\s*<th[^<>]*>\s*<span[^<>]*>([^<>]*)<\/span>\s*<\/th>(.*)/) != null) || (tableHeader.match(/^\s*<th[^<>]*>([^<>]*)<\/th>(.*)/) != null)) {
										 tableHeaderCells.push(RegExp.$1);
										 tableHeader = RegExp.$2;
									 }
									 var row = "";
									 var sectionName = "";
									 var companyKey = "";
									 var cleanUp = "";
									 var companyCount = 0;
									 while(tableBody.match(/^\s*<tr[^<>]*>(((?!<\/tr>)[\s\S])*)<\/tr>([\s\S]*)/) != null) {
										 row = RegExp.$1;
										 tableBody = RegExp.$3;
										 if (row.match(/<td[^<>]*>/g).length == 1) {
											 row.match(/^\s*<td[^<>]*>(<?[^<>]*>?)<\/td>/);
											 sectionName = RegExp.$1;
											 cleanUp = RegExp.$1;
											 if (cleanUp.match(/^\s*(.*)\s*$/) != null) {
												 sectionName = RegExp.$1;
											 }
											 tableBodyCells[sectionName] = {};
										 } else if (row.match(/<td[^<>]*>/g).length == tableHeaderCells.length) {
											 var rowElements = {};
											 for(var i=0; i < tableHeaderCells.length;i++) {
                                                 row.match(/^\s*<td[^<>]*>([^<>]*<?[^<>]*>?[^<>]*<?[^<>]*>?)<\/td>(.*)/);
												 rowElements[tableHeaderCells[i]] = RegExp.$1;
												 row = RegExp.$2;
												 cleanUp = RegExp.$1;
                                                 //NOTE : Second condition for special case of html styling in td values
                                                 if ((cleanUp.match(/^\s*<[^<>]*>(.*)<[^<>]*>\s*$/) != null) || (cleanUp.match(/^\s*([^<>]*<[^<>]*>[^<>]*<[^<>]*>)\s*$/) != null)) {
													 rowElements[tableHeaderCells[i]] = RegExp.$1;
												 }
												 cleanUp = RegExp.$1;
												 if (cleanUp.match(/^\s*(.*)\s*$/) != null) {
													 rowElements[tableHeaderCells[i]] = RegExp.$1;
												 }
											 }
											 //company symbol is used as the company key within a section
											 companyKey = rowElements[tableHeaderCells[1]];
											 tableBodyCells[sectionName][companyKey] = {};
											 tableBodyCells[sectionName][companyKey] = rowElements;
											 var modelItem = {};
											 modelItem['companySymbol'] = companyKey;
											 modelItem['stockQuoteChange'] = tableBodyCells[sectionName][companyKey][tableHeaderCells[16]];
											 modelItem['stockQuotePercentChange'] = tableBodyCells[sectionName][companyKey][tableHeaderCells[15]];
											 modelItem['sectionName'] = sectionName;
											 modelItem['title'] = sectionName + " " + companyKey;
											 if (modelItem['stockQuoteChange'] > 0) {
												 modelItem['changeEffect'] = "#00FF00";
											 } else if (modelItem['stockQuoteChange'] < 0) {
												 modelItem['changeEffect'] = "#FF0000";
											 } else {
												 modelItem['changeEffect'] = "#0000FF";
											 }
											 tableBodyCells[sectionName][companyKey]['changeEffect'] = modelItem['changeEffect'];
											 if (listEmpty) {
												msg.model.append(modelItem);
											 } else {
												msg.model.set(companyCount, modelItem);
											 }
											 companyCount++;
										 } else {
											 console.log("Unknown Row : ",row);
											 errorMessage["error"] = "Error in reading data from source.";
											 WorkerScript.sendMessage({'reply': errorMessage});
											 return;
										 }
									 }
                                     console.log(JSON.stringify(tableBodyCells));
									 msg.model.sync();
									 var reply = {};
									 reply['data'] = tableBodyCells;
									 reply['marketStatus'] = marketStatus;
									 WorkerScript.sendMessage({'reply': reply});
								 }
							 }
					 request.open('GET', 'http://adx.ae/English/MarketWatch/Pages/MWLite.aspx');
					 request.send(null);
				 } else if (msg.action == "updateStockQuoteDetailsList") {
					 request.onreadystatechange = function() {
								 if (request.readyState == 4) {
                                    //TODO : Prospective
								 }
							 }
					 request.open();
					 request.send(null);
				 } else {
					 console.log("UNKNOWN ACTION");
				 }
				 return;
			 }
